SystemOrganization addCategory: #Forum!
SystemOrganization addCategory: 'Forum-Announcements'!
SystemOrganization addCategory: 'Forum-Application'!
SystemOrganization addCategory: 'Forum-Browser'!
SystemOrganization addCategory: 'Forum-Model'!
SystemOrganization addCategory: 'Forum-Tests'!

QCParentObject subclass: #FOAuthor
	instanceVariableNames: 'userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAuthor methodsFor: 'default values' stamp: 'DiegoLont 1/22/2014 13:23'!
curLanguage
	^nil! !

!FOAuthor methodsFor: 'accessing' stamp: 'DiegoLont 1/21/2014 15:04'!
newQuestion
	^self model newQuestion
		author: self;
		yourself! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password
	^ password! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password: anObject
	password := anObject! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:28'!
userName
	^ userName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:27'!
userName: aUserName
	userName := aUserName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 1/28/2013 16:05'!
username
	^ userName! !

TestCase subclass: #FOTestAnswer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

TestCase subclass: #FOTestAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOTestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAnswerQuestion
	|model author question answer|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	answer := question newAnswer: author.
	self assert: author equals: answer author.
	self assert: (question hasAnswer: answer)! !

!FOTestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAskQuestion
	|model author question|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	self assert: author equals: question author.
	self assert: (model hasQuestion: question)! !

!FOTestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorHasUsername
	|author|
	author := FOAuthor new
		userName: 'Kent';
		yourself.
	self assert: 'Kent' equals: author userName! !

!FOTestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorKnowsModel
	|author model|
	model := FOModel new.
	author := model newAuthor.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

!FOTestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 23:53'!
testAuthorNamedKnowsModel
	|author model|
	model := FOModel new.
	author := model authorNamed: 'Martin'.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

TestCase subclass: #FOTestModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelCanFindAuthorsByName
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:44'!
testModelCanFindAuthorsByNameAndPassword
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testModelDoesntKnowOtherQuestions
	|model question| 
	model := FOModel new.
	question := FOQuestion new.
	self deny: (model hasQuestion: question).
! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsAuthors
	|model author| 
	model := FOModel new.
	author := model newAuthor.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsQuestions
	|model question| 
	model := FOModel new.
	question := model newQuestion.
	self assert: (model hasQuestion: question).
	self assert: (model questions size = 1).! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTags
	|model tag| 
	model := FOModel new.
	tag := model newTag.
	self assert: (model tags size = 1).
	self assert: (model tags includes: tag)! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTheNumberOfQuestions
	|model question| 
	model := FOModel new.
	self assert: (model questions size = 0).
	question := model newQuestion.
	self assert: (model questions size = 1).
	question := model newQuestion.
	self assert: (model questions size = 2).
	question := model newQuestion.
	self assert: (model questions size = 3).! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 12:00'!
testModelReturnsNewAuthorWhenRegistering
	|model author| 
	model := FOModel new.
	author := model registerAuthor: 'Joel' password: 'leoJ'.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:46'!
testModelReturnsNilIfPasswordWrong
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel' password: 'leoJ') equals: author.
	self assert: (model authorNamed: 'Joel' password: 'leo') equals: nil.
	! !

!FOTestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testTheSharedModelExists
	|model|
	model := FOModel default.
	self assert: (model questions size>= 0)! !

TestCase subclass: #FOTestPost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCannotVoteOwnPost
	|post author|
	post := FOPost new.
	post author: author.
	post voteUp: author.
	self assert: 0 equals: post voteSize.
	post voteDown: author.
	self assert: 0 equals: post voteSize! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostHasContent
	|post|
	post := FOPost new
		content: 'Question, answer or comment?';
		yourself.
	self assert: 'Question, answer or comment?' equals: post content! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:15'!
testPostShouldShowDefaultAuthorName
	|post |
	post := FOPost new.
	self assert: 'Anonymous' equals: post authorName
	! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:17'!
testPostShouldShowRealAuthorName
	|post author|
	post := FOPost new.
	author := FOAuthor new
		userName: 'Willem';
		yourself.
	post author: author.
	self assert: 'Willem' equals: post authorName
	! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostStartsWithZeroVotes
	|post|
	post := FOPost new.
	self assert: 0 equals: post voteSize! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:09'!
testPostVoteSize
	|post author1 author2|
	post := FOAnswer new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteSize.
	post voteUp: author1.
	self assert: 1 equals: post voteSize.
	post voteDown: author2.
	self assert: 2 equals: post voteSize.
	
! !

!FOTestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostVoteValue
	|post author1 author2|
	post := FOPost new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteValue.
	post voteUp: author1.
	self assert: 1 equals: post voteValue.
	post voteDown: author2.
	self assert:  0 equals: post voteValue.
	
! !

TestCase subclass: #FOTestQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 4/3/2013 20:58'!
testNewQuestionIsNotAnswered
	| question |
	question := FOQuestion new.
	self deny: question isAnswered.! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOneAnswerIsNotUnanswered
	|question answer |
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: question isAnswered! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOnlyOneAnswerCanBeAccepted
	|question answer answer2|
	question := FOQuestion new.
	answer := question newAnswer.
	answer2 := question newAnswer.
	self assert: (question canAccept: answer).
	self assert: (question canAccept: answer2).
	answer accept.
	self assert: question hasAcceptedAnswer.
	self deny: (question canAccept: answer2).! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasRightNumberOfAnswersString
	|question answer|
	question := FOQuestion new.
	self assert: '0 Answers' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '1 Answer' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '2 Answers' equals: question answerSizeString.! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 22:24'!
testQuestionHasTagString
	|question|
	question := FOQuestion new
		addTag: (FOTag new 
			description: 'one';
			yourself);
		addTag: (FOTag new
			description: 'two';
			yourself);
		yourself.
	self assert: 'one two' equals: question tagString ! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasTitle
	|question|
	question := FOQuestion new
		title: 'How does this work?';
		yourself.
	self assert: 'How does this work?' equals: question title ! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 1/29/2014 14:17'!
testQuestionIsAnswered
	| question answer |
	question := FOQuestion new.
	answer := question newAnswer.
	answer accept.
	self assert: question hasAcceptedAnswer
	! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsAnswers
	|question answer|
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: (question hasAnswer: answer).
	answer := FOAnswer new.
	self deny: (question hasAnswer: answer)
! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsComments
	|question comment|
	question := FOQuestion new.
	comment := question newComment.
	self assert: (question hasComment: comment).
	comment := FOComment new.
	self deny: (question hasComment: comment).
	! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsNumberOfAnswers
	|question answer|
	question := FOQuestion new.
	self assert: 0 equals: question answerSize.
	answer := question newAnswer.
	self assert: 1 equals: question answerSize.! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowstags
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: question tags size.
	self assert: (question hasTag: tag)
		! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnaccepted
	|question|
	question := FOQuestion new.
	self deny: question hasAcceptedAnswer! !

!FOTestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnanswered
	|question|
	question := FOQuestion new.
	self deny: question isAnswered! !

TestCase subclass: #FOTestTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOTestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagHasDescription
	|tag|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.
	self assert: 'Smalltalk' equals: tag description! !

!FOTestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagKnowsQuestions
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	self assert: 0 equals: tag questions size.
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: tag questions size.
		! !

QCSession subclass: #FOSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

Tutorial subclass: #FOTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Browser'!

!FOTutorial class methodsFor: 'accessing' stamp: 'DiegoLont 1/29/2014 13:01'!
title
	^'Using smalltalk seaside'! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 11:14'!
exercises
	^TutorialText new
	title: 'Exercises';
	text: 
'
The best way to get to know smalltalk is to do some programming.
';
	children: #( testDrivenDevelopment forumExercises )! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 14:01'!
forumAnswer
	^TutorialText new
	title: '2. An answer can be accepted by the question''s author.';
	text: 
'
Here we have to do a little more work:
- you have to modifiy the domain code to allow only the question''s author to accept an answer. Write a test for this and make it green.
- Modify the rendering that the question''s author is allowed to accept an answer and show this answer first.
- Also make it possible to change the accepted answer. Note: only one answer should be allowed to be accepted (test!!)
'! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 13:58'!
forumComments
	^TutorialText new
	title: '1. Both questions and answers can have comments.';
	text: 
'
Like exercise 3, most of the domain code is writter. Verify this, and modify the proper rendering methods.
'! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 13:25'!
forumExercise0
	^TutorialText new
	title: 'Make some content';
	text: 
'
We begin by generating some content for the website.
We do this by simply using the website to register ourselfs (note we automatically login, when we do this) and add some questions.
Stay logged in, do not try to logout yet, this will be part of the next exercise.
'! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 13:41'!
forumExercise1
	^TutorialText new
	title: 'Logging out';
	text: 
'
On the place where "5073" is shown there should be a button allowing us to log out when logged in.
Since being able to logout mainly consists of user interaction, we do not start by writing a test. One could argue that we should, using a browser test, like "Silenium", but for today using the webpage ourself will do.
';
	children: #( forumExercise1Step1 forumExercise1Step2 forumExercise1Step3 forumExercise1Step4 )! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 13:33'!
forumExercise1Step1
	^TutorialText new
	title: '1. Make sure you are logged in.';
	text: 
'Verify you are still logged in. If not, log in.'! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 13:32'!
forumExercise1Step2
	^TutorialText new
	title: '2. Find the method with: ''5073''';
	text: 
'Switch to Smalltalk.
Find the place: Open a workspace. Type 5073, select it, and right click in the workspace. Select
- Extended Search, Method strings with it. (Or use Cmd-Shift-E).'! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 14:38'!
forumExercise1Step3
	^TutorialText new
	title: '3. Replace ''5073'' with a logout button.';
	text: 
'
Change the text 5073 and save the method. Switch to the web browser and reload the page to confirm that this is the correct place.
Change the line
>	canvas text: ''5073'' ]
into
>	canvas submitButton on: #logout of: self ]
We now see that the button is different than the other buttons.
This is because we use bootstrap. So we should us a different button. Replace
>	submitButton
by
>	tbsButton beExtraSmall;
'! !

!FOTutorial methodsFor: 'exercise1' stamp: 'DiegoLont 1/29/2014 15:14'!
forumExercise1Step4
^TutorialText new
	title: '4. Make the logout work.';
	text: 
'
Switch to the web browser, reload and click logout. Click debug and switch to Smalltalk.
Create method in the debugger and open another code browser to check what code should be added in this method.
- See login. Here the method self user: is called. Find user: in hierarchy. 
- Method delegates to other class (something with session). We need to browse this class.
- ... we search on the implementers of "user:". Right click the method and search for the implementers. (cmd-m)
- ... one of the implementating classes is a session, browse this class.
- See that nilling the user does logout, so we should try nilling the user.
- This can done by:
>	self user: nil'! !

!FOTutorial methodsFor: 'exercise2' stamp: 'DiegoLont 1/29/2014 13:50'!
forumExercise2
	^TutorialText new
	title: 'User can only vote once';
	text: 
'
We want to enforce that a user can only vote once. So we write tests that check on this behaviour.
';
	children: #( forumExercise2Step1 forumExercise2Step2 forumExercise2Step3 forumExercise2Step4 )! !

!FOTutorial methodsFor: 'exercise2' stamp: 'DiegoLont 1/29/2014 13:44'!
forumExercise2Step1
	^TutorialText new
	title: '1. Find the place where we should implement this behaviour.';
	text: 
'
We want to enforce that a user can only vote once. So we write tests that check on this behaviour.
We browse the domain model.
> FOQuestion
Is the most likely place to implement this, as it is a constraint on a question.
> FOPost
Questions are posts. For all posts it is true that each user can only vote once.
FOPost is the place to be, so we add a testcase to TestPost.
'! !

!FOTutorial methodsFor: 'exercise2' stamp: 'DiegoLont 1/29/2014 13:47'!
forumExercise2Step2
	^TutorialText new
	title: '2. Add a (red) test.';
	text: 
'
Go to FOTestPost
- Change testPostVoteSize into testVotesHaveUniqueAuthor and save.
- Run the test and see everything works (green).
- Change the test so that one author votes twice and add corresponding checks.
When an author votes twice, there still should be one vote.
> self assert: 1 equals: post voteSize
Test both voting up and voting down.
- Run the test and see that it is broken (red).
'! !

!FOTutorial methodsFor: 'exercise2' stamp: 'DiegoLont 1/29/2014 13:49'!
forumExercise2Step3
	^TutorialText new
	title: '3. Make test green.';
	text: 
'
So now we have our test, we want to make the actual implementation.
- Go back to FOPost and change the methods voteUp and voteDown, so these methods don''t add a vote when the author already voted.
- Run tests and see that it works.
- Go to the website and see that it works.
'! !

!FOTutorial methodsFor: 'exercise2' stamp: 'DiegoLont 1/29/2014 13:50'!
forumExercise2Step4
	^TutorialText new
	title: '4. Last vote counts.';
	text: 
'
Also add a testcase that verifies that the last vote counts, since we want a user to be able to change its mind.
- Change testPostVoteValue into testLastVoteCounts.
- Add the corresponding tests.
- Run tests and if needed, fix implementation untill tests are green.
'! !

!FOTutorial methodsFor: 'exercise3' stamp: 'DiegoLont 1/29/2014 13:54'!
forumExercise3
	^TutorialText new
	title: 'Adding answers';
	text: 
'
It is nice we can post questions, but we also want to be able to add answers to these questions.
1. The code for creating and adding an anwer already exists, with tests. The class FOAnswer will suffice for now and you can add an answer to a question by: FOQuestion newAnswer: anAuthor content: aString. Note that this returns the answer.
2. Find where a single question is rendered.
3. Notice this code contains some snippets you might find usefull (but are currently dead code).
4. Add a form (canvas form:) to this component that renders a memo (canvas memo) and a button to submit the answer (canvas submitButton)
5. Make sure to render the answers to a question
';
	children: #( forumExercise3Step1 forumExercise3Step2 )! !

!FOTutorial methodsFor: 'exercise3' stamp: 'DiegoLont 1/29/2014 13:53'!
forumExercise3Step1
	^TutorialText new
	title: '1. See that implementation is done.';
	text: 
'
2. Find where a single question is rendered.
3. Notice this code contains some snippets you might find usefull (but are currently dead code).
4. Add a form (canvas form:) to this component that renders a memo (canvas memo) and a button to submit the answer (canvas submitButton)
5. Make sure to render the answers to a question
'! !

!FOTutorial methodsFor: 'exercise3' stamp: 'DiegoLont 1/29/2014 13:53'!
forumExercise3Step2
	^TutorialText new
	title: '2. Change rendering of a question.';
	text: 
'
- Find where a single question is rendered.
- Notice this code contains some snippets you might find usefull (but are currently dead code).
- Add a form (canvas form:) to this component that renders a memo (canvas memo) and a button to submit the answer (canvas submitButton)
- Make sure to render the answers to a question
'! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 14:01'!
forumExercise4
	^TutorialText new
	title: 'Additional exercises';
	text: 
'
If you are faster then the others, don''t let this stop you writing smalltalk code. Here we have some additional feature requests
';
	children: #( forumComments forumAnswer forumSearch forumTags forumTimestamp )! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 13:24'!
forumExercises
	^TutorialText new
	title: 'Agile overflow';
	text: 
'
For the remainder of the exercises we use a demo application: "Agile overflow".
- This demo application, is a web application based on Seaside and inspired by Stack overflow.
- It is missing a lot of functionality.
- We put up this demo application, so you have a good starting point to do some real developing.

Go to: "http://localhost:8181/AgileOverflow" to open the demo application.

The following exercises all have hints, please try them first without the hints.
';
	children: #( forumExercise0 forumExercise1 forumExercise2 forumExercise3 forumExercise4 )! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 14:07'!
forumSearch
	^TutorialText new
	title: '3. I want to be able to search instead of browse.';
	text: 
'
When the number of questions grow large, I should be able to search instead of browse through the list. Add a possiblity to search. Search results should be ordered by score.
'! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 14:03'!
forumTags
	^TutorialText new
	title: '4. Questions can have tags.';
	text: 
'
To allow for better search results, questions can have tags. Make sure the search searches on these tags first.
'! !

!FOTutorial methodsFor: 'exercise4' stamp: 'DiegoLont 1/29/2014 14:06'!
forumTimestamp
	^TutorialText new
	title: '5. Posts should have a timestamp.';
	text: 
'
Sometimes I want to see the newest question, not the ones with the highest score. The same goes for the answers. Add a timestamp to a post, and allow for sorting on this timestamp. Add tests for the sorting, and add a switch button to sort on date and/or score.
'! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 11:10'!
furtherReading
	^TutorialText new
	title: 'Further reading';
	text: 
'The code for this tutorial can be found at

http://ss3.gemstone.com/ss/SpaTutorial

The MOOSE environment can be found at

http://www.moosetechnology.org

The book on MOOSE is

http://www.themoosebook.org/

The MOOSE framework builds on top of the Pharo Smalltalk environment.
The Pharo environment is found at:

http://www.pharoproject.org

The book explaining how to use Pharo is

http://www.pharobyexample.org.

Serge Demeyer, Stéphane Ducasse & Oscar Nierstrasz (2008) Object-Oriented Reengineering Patterns.
http://creativecommons.org/licences/by-sa/3.0/

Robert Chatley wrote on the SPA2011 egg race at

http://chatley.com/posts/06-20-2011/spa-great-egg-race/

The code written by Micheal Feathers to extract data from git repositories

https://github.com/michaelfeathers/repodepot-ruby'! !

!FOTutorial methodsFor: 'introduction' stamp: 'StephanEggermont 1/28/2014 13:37'!
gettingStarted
	^TutorialText new
	title: 'Getting Started with Smalltalk';
	text: 
'Using Pharo Smalltalk, Moose & Seaside';
	children: #(smalltalk moose seaside)! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 11:01'!
moose
	^TutorialText new
	title: 'Moose';
	text: 
'
- MOOSE is a platform for software and data analysis.
- It is an open source project since 1996.
- It is supported by several research groups around the world.

It consists of:
- Visualization engines
- Graph and layout algorithms
- Parsing tools'! !

!FOTutorial methodsFor: 'introduction' stamp: 'DiegoLont 1/29/2014 11:00'!
seaside
	^TutorialText new
	title: 'Seaside';
	text: 
'
- Seaside is a library for web applications.
- It is an open source project since 1996.
- It is supported by several research groups around the world.

It consists of:
- A fluent DSL
- Widgets
- Support for several javascript libraries, like jQuery and bootstrap

';
	children: #(  )! !

!FOTutorial methodsFor: 'introduction' stamp: 'DiegoLont 1/29/2014 11:08'!
smalltalk
	^TutorialText new
	title: 'Smalltalk';
	text: 
'
Smalltalk is a very simple object oriented language
- It has only 6 "keywords": self, super, thisContext, true, false, nil
- Everything is an object
- Very powerfull environment (very short feedback loop)

All depends on its libary. This means there are several dialects of smalltalk. We use:
- Pharo. Open source, with a growing community.
- Gemstone. A object oriented database, with among its customers the largest transport company.
'! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 11:17'!
testDrivenDevelopment
	^TutorialText new
	title: 'Test Driven Development';
	text: 
'
Test driven development (TDD) is invented in smalltalk.
- Write your test first.
- Run your test (it will fail: so test will be "red").
- Fix your test, so it will pass (test will be green).
When all tests are green, you can refactor if need be. Check if tests are green afterwards.

In smalltalk we push TDD to the extreme.
- We write our test.
- We run our test.
- We fix our test, while it is running.
'! !

!FOTutorial methodsFor: 'tutorial' stamp: 'StephanEggermont 1/28/2014 13:33'!
thanks
	^TutorialText new
	title: 'Thanks';
	text: 
'This workshop uses code written for the egg race at SPA2011.

We would like to thank:
- Willem van den Ende for working with us on this workshop and presenting an earlier version on SPA2012.
- Michael Feathers for the scripts and data from the git repositories.
- Marc Evers & Robert Chatley for the egg race inspiration. 

'! !

!FOTutorial methodsFor: 'tutorial' stamp: 'DiegoLont 1/29/2014 11:24'!
tutorial
	^#(gettingStarted
	exercises
	furtherReading
	thanks)! !

QCPageChoice subclass: #FOAgileOverflow
	instanceVariableNames: 'loginName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAgileOverflow class methodsFor: 'class initialization' stamp: 'DiegoLont 1/22/2014 14:41'!
initialize
	"Registers this application as webpage
		FOAgileOverflow initialize.
	"
	(WAAdmin register: self asApplicationAt: 'AgileOverflow')
		preferenceAt: #sessionClass
			put: FOSession;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: TBSDevelopmentLibrary;
		addLibrary: FOFileLibrary;
		yourself
! !

!FOAgileOverflow class methodsFor: 'class initialization' stamp: 'DiegoLont 1/29/2014 14:58'!
initializeDevelopment
	"Registers this application with a debug handler
		FOAgileOverflow initializeDevelopment.
	"
	| app |
	app := (WAAdmin register: self asApplicationAt: 'AgileOverflow')
		preferenceAt: #sessionClass
			put: FOSession;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: TBSDevelopmentLibrary;
		addLibrary: FOFileLibrary;
		yourself.
	(app filters detect: #isExceptionFilter) configuration at: #exceptionHandler put: WADebugErrorHandler
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion
	self announce: FOGoAskQuestion! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion2
	self announce: FOGoAskQuestion2! !

!FOAgileOverflow methodsFor: 'initialization' stamp: 'DiegoLont 1/22/2014 13:04'!
initialize 
	super initialize.
	self addPage: FOHome new announcement: FOGoHome.
	self addPage: FOAskQuestionSeaside new announcement: FOGoAskQuestion.
	self addPage: FOAskQuestionMagritte new announcement: FOGoAskQuestion2.
	self addPage: FOAllQuestions new announcement: FOGoAllQuestions.
	self addPage: FOViewQuestion new announcement: FOGoViewQuestion symbol: #question.
! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 11:53'!
login
	self user: (FOModel default authorNamed: loginName password: password).! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName
	^ loginName! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName: anObject
	loginName := anObject! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 4/3/2013 20:46'!
logout
	self user: nil.! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password
	^ password! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password: anObject
	password := anObject! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 12:03'!
register
	self user: (FOModel default registerAuthor: loginName password: password).! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:29'!
renderBottomOn: canvas! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:54'!
renderContentOn: canvas
	self renderTopOn: canvas.
	canvas div
		class: 'main-wrapper';
		with: [ self
			renderHeaderOn: canvas;
			renderMainOn: canvas;
			renderBottomOn: canvas ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:56'!
renderHeaderOn: canvas
	canvas tbsPageHeader: [ 
		canvas heading
			class: 'home';
			with: [
				canvas anchor 
					callback: [self goHome];
					with: 'AgileOverflow'] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:48'!
renderLoginOrRegisterOn: canvas
	canvas tbsFormGroup: [ 
		canvas label for: 'username'; class: 'sr-only'; with: 'User name'.
		canvas textInput tbsFormControl; id: 'username'; placeholder: 'Enter username'; on: #loginName of: self.
		canvas space].

	canvas tbsFormGroup: [ 
		canvas label for: 'password'; class: 'sr-only'; with: 'Password'.
		canvas passwordInput tbsFormControl id: 'password'; placeholder: 'Password'; on: #password of: self.
		canvas space]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:56'!
renderMainOn: canvas
	canvas div
		class: 'top';
		with: [self renderQuestionHeaderOn: canvas].
	canvas div 
		class: 'main';
		with: [canvas render: self currentPage]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 1/24/2014 10:44'!
renderQuestionHeaderOn: canvas
	canvas tbsForm beInline; with: [
		self isLoggedIn ifFalse: [ self renderLoginOrRegisterOn: canvas ].
		canvas tbsButtonToolbar: [ 
			canvas tbsButtonGroup beSmall with: [ 
				self isLoggedIn
					ifTrue: [ 
						canvas tbsButton beDefault; on: #askQuestion of: self.
						canvas tbsButton beDefault; on: #askQuestion2 of: self ]
					ifFalse: [
						canvas tbsButton beDefault; 
							callback:[self login];
							with: [canvas tbsGlyphIcon iconLogin.
								canvas space; 
									text: 'Login'].
						canvas tbsButton beDefault; on: #register of: self ] ].
			canvas tbsButtonGroup beSmall with: [ 
				canvas tbsButton beDefault; on: #viewAllQuestions of: self ] ] ].
! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:04'!
renderTopMetaOn: canvas
	canvas tbsButtonToolbar with: [
		canvas tbsButtonGroup beExtraSmall
			with: [
				canvas tbsButton beDefault; with: 'chat'.
				canvas tbsButton beDefault; with: 'meta'.
				canvas tbsButton beDefault; with: 'about'.
				canvas tbsButton beDefault; with: 'faq' ] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/29/2014 15:16'!
renderTopOn: canvas
	canvas tbsForm
		beInline;
		class: 'topbar';
		with: [
			canvas tbsFormGroup: [ self renderTopUserOn: canvas ].
			canvas space.
			canvas tbsFormGroup: [ self renderTopMetaOn: canvas ].
			canvas space.
			canvas tbsFormGroup: [ self renderTopSearchOn: canvas ] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:04'!
renderTopSearchOn: canvas
	canvas textInput on: #search of: self! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/29/2014 15:17'!
renderTopUserOn: canvas
	canvas text: self username.
	self ifLoggedIn: [ 
		canvas space.
		canvas text: '5073' ].
	canvas space.
! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:24'!
search
	" todo: search "
	^'search'! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 14:55'!
search: aString
	^'search'! !

!FOAgileOverflow methodsFor: 'updating' stamp: 'StephanEggermont 5/19/2011 13:46'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'AgileOverflow'
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
viewAllQuestions
	self announce: FOGoAllQuestions! !

WAFileLibrary subclass: #FOFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOFileLibrary methodsFor: 'accessing' stamp: 'DiegoLont 1/29/2014 15:16'!
mainCss
	^'
.topbar{
 	width: 100%;
 	background-color: #eeeeee;
 	height: 525x;
 	border: 0;
 	margin: 0;
 	padding: 5px 10px 5px 10px;
 	text-align: right;
}
	.hlinks{
		float: right
	}
	.userspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 15px 20px 2px 0px;
	}
	body{
		font-family:Arial,Liberation Sans,DejaVu Sans,sans-serif;
		border: 0;
		margin: 0;
		padding: 0;
	
	}
	.home a {
		color: #111;
		text-decoration: none;
	}
	.main-wrapper { 
		padding: 0 0 0 20px;
	}
.question{
	float: left;
	border-bottom: 1px dotted #999;
	overflow: hidden;
	width: 730px;
	display: block;
}
.votes{
	display: block;
	float: left;
	width: 38px;
	padding: 5px;
	text-align: center;
}	
.votes a{
	text-decoration: none;
	color: #aaa;
}
.summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.question .count{
	font-size: 190%;
}
.summary .title{
	font-size: 14px;
	height: 20px;
}
.summary a{
	text-decoration: none;
}
.summary .contents{
	height: 30px;
	overflow: hidden;
	font-size: 12px;
}
.summary .author{
	float: right;
	font-size: 12px;
	color: blue;
}
.view-answer {
	padding: 5px;
	border-bottom: 1px solid #aaa;
}
view-answer h2 {
	font-size: 16px;
}
answer-summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.view-question h1{
	padding: 5px;
	font-size: 24px;
	border-bottom: 1px solid #aaa;
}
	'! !

!FOFileLibrary methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 13:45'!
selectorsToInclude
	^#(mainCss)! !

QCObject subclass: #FOPost
	instanceVariableNames: 'author votes content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost commentStamp: 'StephanEggermont 5/19/2011 11:10' prior: 0!
A F2Post has an author and can be voted on!

FOPost subclass: #FOAnswer
	instanceVariableNames: 'accepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accept
	accepted := true.! !

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accepted
	^accepted ifNil: [^false]! !

FOPost subclass: #FOComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:08'!
author
	^author! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
author: anAuthor
	author := anAuthor! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:17'!
authorName
	author ifNil: [^'Anonymous'].
	^ author userName! !

!FOPost methodsFor: 'testing' stamp: 'DiegoLont 1/22/2014 11:20'!
canRemove
	^false! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 11:06'!
containerDefaults: aContainer
	<magritteContainer>
	^aContainer
		! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content
	^content! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content: aContent
	content := aContent! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionContents
	<magritteDescription>
	^MAMemoDescription new
		label: 'Contents';
		accessor: #content;
		beRequired;
		requiredErrorMessage: 'Contents needs to be filled out.';
		yourself! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionNumberOfVotes
	<magritteDescription>
	^MANumberDescription new
		label: '#votes';
		accessor: #voteSize;
		beReadonly;
		priority: 200;
		yourself! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionVotes
	<magritteDescription>
	^MANumberDescription new
		label: 'vote';
		accessor: #voteValue;
		beReadonly;
		priority: 100;
		yourself! !

!FOPost methodsFor: 'initialization' stamp: 'DiegoLont 1/22/2014 13:15'!
initialize
	super initialize.
	author := self user! !

!FOPost methodsFor: 'accessing' stamp: 'DiegoLont 8/4/2011 09:59'!
voteDown: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote down: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
voteSize
	^self votes size! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
voteUp: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote up: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:23'!
voteValue
	^self votes inject: 0 into: [:sum :each | sum+ each increment]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
votes
	^votes ifNil: [votes := OrderedCollection new]! !

FOPost subclass: #FOQuestion
	instanceVariableNames: 'answers title tags comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:00'!
addTag: aTag
	aTag questions add: self.
	self tags add: aTag! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:40'!
answerSize
	^self answers size! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:43'!
answerSizeString
	self answers size = 1 ifTrue: [^'1 Answer'].
	^self answers size asString,' Answers'! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:10'!
answers
	^answers ifNil: [answers := OrderedCollection new]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:27'!
canAccept: anAnswer
	^self hasAcceptedAnswer not and: [self answers includes: anAnswer]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:11'!
comments
	^comments ifNil: [comments := OrderedCollection new]! !

!FOQuestion methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:43'!
descriptionTitle
	<magritteDescription>
	^MAStringDescription new
		label: 'Title';
		accessor: #title;
		beRequired;
		requiredErrorMessage:'A title is required.';
		yourself! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:12'!
hasAcceptedAnswer
	^self answers anySatisfy: [:each |each accepted]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:09'!
hasAnswer: anAnswer
	^self answers includes: anAnswer! !

!FOQuestion methodsFor: 'testing' stamp: 'WillemvandenEnde 10/3/2011 14:13'!
hasAnswers
	 ^answers notNil.! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:10'!
hasComment: aComment
	^self comments includes: aComment! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 11:59'!
hasTag: aTag
	^self tags includes: aTag! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:19'!
isAnswered
	^self answers size > 0! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer
	|answer|
	answer := FOAnswer new.
	self answers add: answer.
	^answer! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer: anAuthor
	^self answers add: (FOAnswer new
		author: anAuthor;
		yourself).
! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newComment
	^self comments add: FOComment new.
! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 22:22'!
tagString
	^String streamContents: [:s |
		self tags do: [:tag |
			s nextPutAll: tag description] separatedBy: [s space]]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:59'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:32'!
title
	^title! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:44'!
title: aTitle
	title := aTitle.
! !

Announcement subclass: #FOGoAllQuestions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

Announcement subclass: #FOGoViewQuestion
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

!FOGoViewQuestion class methodsFor: 'instance creation' stamp: 'StephanEggermont 4/28/2011 22:40'!
on: aQuestion
	^self new
		question: aQuestion;
		yourself! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question
	^ question! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question: anObject
	question := anObject! !

Object subclass: #FOBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Browser'!

!FOBrowser class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/3/2013 15:13'!
open
	^self new browser openOn: self! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 4/3/2013 15:48'!
browser
	|browser|
	browser := GLMTabulator new.
	browser 
		title: 'Forum Code Quality';
		row: #details.
	browser transmit to: #details; andShow: [ :a |
		self complexityOn: a.
		self complexity2On: a.
		self uncategorizedOn: a.
		self distibutionMapOn: a].
	^browser.
! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 1/23/2014 15:58'!
complexity2On: a
	a roassal
		title: 'Package Complexity';
		painting: [:view|
			| packages  allClasses|
			packages := (RPackageOrganizer default packages select: [ :p | 
				p packageName beginsWith: 'Forum' ]) first packages.
			allClasses := IdentitySet new.
			packages do: [ :p | allClasses addAll: p classes ].				
			view interaction action: #browse.
			view shape rectangle.
			view nodes: packages forEach: [ :aPackage |
				view interaction action: #browse.
				view shape rectangle 
				width: [:cls | cls instVarNames size * 6];
				height: [:cls | cls methods size*2];
				fillColor: (RONColorLinearNormalizer 
					inContext: allClasses 
					withCommand: [:cls |
						cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]]
					lowColor: Color green 
					highColor: Color red).
			view nodes: aPackage classes.
			view treeLayout].
			view edges: allClasses from: #superclass to: #yourself.				
		view gridLayout]
! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:51'!
complexityOn: a
	a roassal
		title: 'Complexity';
		painting: [:view|
"Each node is a class, edges designate inheritance.
Height is linear to the number of method the class defines.
Width is linear to the number of variables the class defines.
Color color is linear to the number of lines of code of the class.
The darkest node designates the class that has the highest number of lines of code"
			| packages classes |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].				
			view interaction action: #browse.
			view shape rectangle
				width: [:cls | cls instVarNames size * 6];
				height: [:cls | cls methods size * 2 ];
				linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]] within: classes.
			view nodes: classes.
			view edgesFrom: #superclass.				
			view treeLayout].
! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:52'!
distibutionMapOn: a
		a roassal 
			title: 'Distribution map';
			painting: [:view |
		"Simple example of a distribution map. 
		Green methods are short. Orange are long. Red are very long"
			| classes d packages  |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].				
			d := IdentityDictionary new.
			classes do: [:aClass | aClass methods do: [:m | d at: m put: m getSource lineCount ] ].

			view shape rectangle withoutBorder.
			view nodes: classes forEach: [ :each |
				view shape label.
				view node: each.
				view node: each forIt: [
					view shape rectangle size: 12;
						if: [:m | (d at: m) < 5 ] fillColor: Color green;
						if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
						if: [:m | (d at: m) >= 25 ] fillColor: Color red.
					view nodes: (each methods sortedAs: [:m | (d at: m) ]).
					view gridLayout gapSize: 2 ].
					view verticalLineLayout ].
	
			view gridLayout]
! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 4/3/2013 15:12'!
mondrianPackage: aPackage
	(aPackage packageName beginsWith: 'Forum') ifTrue: [ ^true ].
	^false.! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:51'!
uncategorizedOn: a
	a roassal 
		title: 'Uncategorized methods';
		painting: [:view |
"This visualization is useful to track down 'as yet unclassified' method categories. This is widely recognized as a bad Smalltalk practice to have such a method category" 

			| packages classes |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].

			view shape rectangle 
				size: 20;
			if: [ :cls | cls organization categories includesAnyOf: #(#'as yet unclassified ' #'as yet unclassified') ] fillColor: Color red.
	
			view interaction action: #browse.
			view nodes: classes.
			view edgesFrom: #superclass.
			view treeLayout].
! !

Object subclass: #FOModel
	instanceVariableNames: 'questions authors tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOModel class
	instanceVariableNames: 'default'!

FOModel class
	instanceVariableNames: 'default'!

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/18/2011 16:04'!
default
	^default ifNil: [default := self new]! !

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/19/2011 16:14'!
reset
	default := nil! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 23:55'!
authorNamed: aName
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:48'!
authorNamed: aName password: aPassword
	^self authors detect: [:each |
		 (each userName = aName) and: [each password = aPassword]]
	 ifNone: [ ^nil].
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:45'!
authors
	^authors ifNil: [authors := OrderedCollection new]! !

!FOModel methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:53'!
descriptionAllQuestions
	<magritteDescription>
	^MAToManyRelationDescription new
		label: 'All questions';
		accessor: #questions;
		classes: (Array with: FOQuestion);
		yourself! !

!FOModel methodsFor: '*forum-application' stamp: 'DiegoLont 1/22/2014 11:19'!
descriptionAllQuestions: aDescription
	<magritteDescription: #descriptionAllQuestions>
	" sets the defaults for rendering this description "
	^aDescription
		componentClass: QCToManyComponent;
		yourself! !

!FOModel methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 15:53'!
hasQuestion: aQuestion
	^self questions includes: aQuestion! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 1/29/2014 14:25'!
model
	^self! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:08'!
newAuthor
	^self authors add: (FOAuthor on: self)
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newQuestion
	^self questions add: FOQuestion new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newTag
	^self tags add: FOTag new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 15:16'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

!FOModel methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 10:59'!
questions: aCollection 
	questions := aCollection! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 12:01'!
registerAuthor: aName password: aPassword
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			password: aPassword;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:48'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

Object subclass: #FOTag
	instanceVariableNames: 'description questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description
	^description! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description: aDescription
	description := aDescription! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:55'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

Object subclass: #FOVote
	instanceVariableNames: 'author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOVote subclass: #FODownVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FODownVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^-1! !

FOVote subclass: #FOUpVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOUpVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^1! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
down: anAuthor
	^FODownVote on: anAuthor! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/18/2011 17:22'!
on: anAuthor
	^self basicNew
		initialize: anAuthor;
		yourself! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
up: anAuthor
	^FOUpVote on: anAuthor! !

!FOVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:26'!
increment
	^self subclassResponsibility! !

!FOVote methodsFor: 'initialization' stamp: 'StephanEggermont 5/18/2011 17:23'!
initialize: anAuthor
	self initialize.
	author := anAuthor! !

QCComponent subclass: #FOAllQuestions
	instanceVariableNames: 'questionsReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAllQuestions methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 14:59'!
children
	^Array with: self questionsReport! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 11:20'!
createQuestionsReport
	^((FOModel default magritteDescription select: [ :each | each accessor = #questions asAccessor ])
			asComponentOn: FOModel default)! !

!FOAllQuestions methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 14:57'!
questionsReport
	^questionsReport ifNil: [questionsReport := self createQuestionsReport]! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:53'!
renderContentOn: canvas
	canvas heading
		level: 2;
		with: 'All questions'.
	self renderQuestionsOn: canvas
	! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 10:51'!
renderQuestionsOn: canvas
	canvas render: self questionsReport! !

!FOAllQuestions methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:00'!
showDetails: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

QCComponent subclass: #FOAskQuestionMagritte
	instanceVariableNames: 'editForm question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:29'!
buttons
	^OrderedCollection new
		add: ([ :d | self save ] -> 'Post your question');
		add: ([ :d | self cancel ] -> 'Cancel');
		yourself! !

!FOAskQuestionMagritte methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:29'!
cancel
	question := nil.
	editForm := nil.
	self announce: FOGoHome! !

!FOAskQuestionMagritte methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 22:47'!
children
	^Array with: self editForm! !

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:11'!
createEditForm
	^self question asComponent
		addForm: self buttons;
		addValidation;
		yourself! !

!FOAskQuestionMagritte methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:52'!
editForm
	editForm ifNil: [editForm := self createEditForm].
	^editForm! !

!FOAskQuestionMagritte methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:11'!
question
	^question ifNil: [ question := FOQuestion new ]! !

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 16:10'!
renderContentOn: canvas
	canvas render: self editForm.! !

!FOAskQuestionMagritte methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:15'!
save
	FOModel default questions add: question.
	self cancel! !

!FOAskQuestionMagritte methodsFor: 'hooks' stamp: 'DiegoLont 1/22/2014 13:12'!
states
	^Array with: self question! !

QCComponent subclass: #FOAskQuestionSeaside
	instanceVariableNames: 'title contents tags author question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestionSeaside methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:31'!
cancel
	contents := nil.
	tags := nil.
	title := nil.
	self announce: FOGoHome
! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents
	^ contents! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents: anObject
	contents := anObject! !

!FOAskQuestionSeaside methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:31'!
postYourQuestion
	FOModel default newQuestion
		title: title;
		content: contents.
	self cancel		! !

!FOAskQuestionSeaside methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:31'!
renderContentOn: canvas
	canvas form:[
		canvas label: 'Title'.
		canvas textInput on: #title of: self.
		canvas break.
		canvas textArea on: #contents of: self.
		canvas break.
		canvas label: 'Tags'.
		canvas textInput on: #tags of: self.
		canvas break.
		canvas submitButton on: #postYourQuestion of: self.
		canvas space.
		canvas submitButton on: #cancel of: self ]! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags
	^ tags! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags: anObject
	tags := anObject! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title
	^ title! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title: anObject
	title := anObject! !

QCComponent subclass: #FOHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOHome methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:54'!
renderContentOn: canvas
	canvas heading
		level: 2;
		with: 'Top questions'.
	canvas div 
		class: 'homepage';
		with: [ self renderQuestionsOn: canvas.]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 15:05'!
renderQuestion: aQuestion on: canvas
	(canvas div)
		class: 'question';
		with: [ 
			self renderVotesOf: aQuestion on: canvas.
			self renderSummaryOf: aQuestion on: canvas] ! !

!FOHome methodsFor: 'rendering' stamp: 'DiegoLont 6/29/2011 16:03'!
renderQuestionsOn: canvas
	(FOModel default questions sort: [:a :b | a voteValue > b voteValue ])do: [:each|
		self renderQuestion: each on: canvas]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 16:19'!
renderSummaryOf: aQuestion on: canvas
	canvas div
		class: 'summary';
		with: [ 
			canvas div 
				class: 'title';
				with: [
			(canvas anchor)
					callback: [ self viewQuestion: aQuestion ];
					with: aQuestion title].
			canvas div
				class: 'contents';
				with: aQuestion content.
			canvas div 
				class: 'author';
				with: aQuestion authorName]
 ! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:42'!
renderVotesOf: aQuestion on: canvas
	|nr|
	nr := aQuestion voteSize.
	canvas div
		class: 'votes';
		with: [ 
			canvas div
				class: 'count';
				with: nr.
			nr = 1 ifTrue: [
				canvas div: 'vote'] 
			ifFalse: [			
				canvas div: 'votes' ]]! !

!FOHome methodsFor: 'actions' stamp: 'StephanEggermont 4/28/2011 22:48'!
viewQuestion: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

QCComponent subclass: #FOViewQuestion
	instanceVariableNames: 'question editForm answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOViewQuestion methodsFor: 'accessing' stamp: 'WillemvandenEnde 10/3/2011 14:22'!
answerEditForm
	editForm ifNil: [editForm := self createAnswerEditForm].
	^editForm! !

!FOViewQuestion methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:29'!
buttons
	^OrderedCollection new
		add: ([ :d | self save ] -> 'Post your question');
		add: ([ :d | self cancel ] -> 'Cancel');
		yourself! !

!FOViewQuestion methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:18'!
cancel
	answer := nil.
	editForm := nil.
	self answer: nil! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:24'!
createAnswerEditForm
	^self postedAnswer asComponent
		addForm: self buttons;
		addValidation;
		yourself! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
downvote 
	question voteDown: self  user ! !

!FOViewQuestion methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:15'!
postedAnswer
	^answer ifNil: [ answer := FOAnswer new ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:20'!
renderAnswer: anAnswer on: canvas
	(canvas div)
		class: 'view-answer';
		with: [ 
			self renderAnswer: anAnswer votesOn: canvas.
			self renderAnswerSummaryOf: anAnswer on: canvas.] ! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:04'!
renderAnswer: anAnswer votesOn: canvas
	canvas div
		class: 'votes';
		with: [ 
					canvas anchor
						callback: [ anAnswer upvote ];
						with: [ canvas html: '&#x25b2;' ].
					canvas break.
					canvas
						text: anAnswer voteValue;
						break.
					canvas anchor
						callback: [ anAnswer downvote ];
						with: [ canvas html: '&#x25bc;' ] ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:08'!
renderAnswerSummaryOf: anAnswer on: canvas
	canvas div
		class: 'answer-summary';
		with: [ 
					canvas
						text: anAnswer content;
						break;
						text: anAnswer authorName ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:46'!
renderAnswersOn: canvas
	question hasAnswers ifFalse: [^self].
	(canvas div)
		class: 'view-answers';
		with: [ 
			canvas heading 
				level: 1;
				with: question answerSizeString..
			question answers do: [:answer|
				self renderAnswer: answer on: canvas.
				]]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:24'!
renderContentOn: canvas
	canvas div
		class: 'view-question';
		with: [ 
					canvas heading: question title.
					self renderVotesOn: canvas.
					canvas
						text: question content;
						break;
						text: question tagString;
						break;
						text: question authorName.
					self renderAnswersOn: canvas.
					canvas render: self answerEditForm ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:41'!
renderVotesOn: canvas
	canvas div
		class: 'votes';
		with: [
	canvas anchor 
		callback: [self upvote];
		with: [canvas html: '&#x25b2;'].
	canvas break.
	canvas
		text: question voteValue;
		break.
	canvas anchor 
		callback: [self downvote];
		with: [canvas html: '&#x25bc;']]
	! !

!FOViewQuestion methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:17'!
save
	question answers add: answer.
	self cancel! !

!FOViewQuestion methodsFor: 'initialization' stamp: 'StephanEggermont 4/28/2011 22:36'!
subject: aQuestion
	question  := aQuestion! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
upvote
	question voteUp: self  user! !
FOAgileOverflow initialize!
